#include "os/machine.h"
#pragma comment(lib, "iphlpapi.lib")
#include <winsock2.h>
#include <iphlpapi.h>
#include <iostream>
#include <iomanip>

void os::GetMacAddress(MacAddr_t* mac)
{
	PIP_ADAPTER_INFO pAdapterInfo = NULL;
	PIP_ADAPTER_INFO pAdapter = NULL;
	DWORD dwRetVal = 0;
	ULONG ulOutBufLen = sizeof(IP_ADAPTER_INFO);

	// 获取所需缓冲区大小
	pAdapterInfo = (IP_ADAPTER_INFO*)malloc(ulOutBufLen);
	if (pAdapterInfo == NULL) {
		std::cerr << "Error allocating memory\n";
		return;
	}

	if (GetAdaptersInfo(pAdapterInfo, &ulOutBufLen) == ERROR_BUFFER_OVERFLOW) {
		free(pAdapterInfo);
		pAdapterInfo = (IP_ADAPTER_INFO*)malloc(ulOutBufLen);
		if (pAdapterInfo == NULL) {
			std::cerr << "Error allocating memory\n";
			return ;
		}
	}

	if ((dwRetVal = GetAdaptersInfo(pAdapterInfo, &ulOutBufLen)) != NO_ERROR) {
		std::cerr << "GetAdaptersInfo failed: " << dwRetVal << "\n";
		free(pAdapterInfo);
		return ;
	}

	static constexpr char hex_map[] = "0123456789abcdef";
	pAdapter = pAdapterInfo;
	if (pAdapterInfo)
	{
		for (uint32_t i = 0; i < pAdapter->AddressLength; i++)
		{
			for (uint32_t j = 0; j < pAdapter->Address[i]; j++)
			{
				
			}
		}
	}


	free(pAdapterInfo);
}